--
-- FIX_FRUIT_GROWTH_DURING_MISSION
--
-- @author:    	Xentro (Marcus@Xentro.se)
-- @website:	www.Xentro.se
-- @history:	v1.0 - 2016-11-02 - Initial implementation
-- 

FIX_FRUIT_GROWTH_DURING_MISSION = {};

function FIX_FRUIT_GROWTH_DURING_MISSION:loadMap()
	-- if GameExtension.MESSAGE_MODE == GameExtension.DEBUG then
		-- addMessage("plantGrowthRateIsLocked", g_currentMission);
		-- addMessage("plantGrowthRate", g_currentMission.missionInfo);
		-- addMessage("isPlantWitheringEnabled", g_currentMission.missionInfo);
	-- end;
end;

function FIX_FRUIT_GROWTH_DURING_MISSION:updateTick(dt)
	if GameExtension.getSetting("FIX_FRUIT_GROWTH_DURING_MISSION", "FRUIT_GROWTH_ACTIVE") then
		if g_currentMission.fieldJobManager ~= nil then
			local fieldJob = g_currentMission.fieldJobManager.currentFieldJob;
			
			if fieldJob ~= nil then
				local oldGrowthRate = fieldJob.backUpValues.plantGrowthRate;
				-- local oldTimeScale = fieldJob.backUpValues.timeScale; -- We leave this alone for now.
				
				-- STATUS_STOPPED = 0
				-- STATUS_STARTING = 1
				-- STATUS_RUNNING = 2
				-- STATUS_FINISHED = 3
				if fieldJob.status == FieldJob.STATUS_STARTING then
					g_currentMission:setPlantGrowthRateLocked(false);
					g_currentMission:setPlantGrowthRate(fieldJob.backUpValues.plantGrowthRate);
					
				elseif fieldJob.status == FieldJob.STATUS_RUNNING then
					-- synch backup value as this will reset your current value
					if g_currentMission.missionInfo.plantGrowthRate ~= oldGrowthRate then
						fieldJob.backUpValues.plantGrowthRate = g_currentMission.missionInfo.plantGrowthRate;
					end;
				end;
			end;
		end;
	end;
end;