--
-- GENERAL
--
-- @author:    	Xentro (Marcus@Xentro.se)
-- @website:	www.Xentro.se
-- @history:	
-- 

GENERAL = {};

function GENERAL:loadMap()
	-- This extend the customTrack script, it will leave the tracks that are made when vehicle is sold.
	g_currentMission.customTrackController 	= true;
	g_currentMission.customTrackSystem		= {};
end;

function GENERAL:deleteMap()
	for _, system in ipairs(g_currentMission.customTrackSystem) do
		system:delete();
	end;
	
	g_currentMission.customTrackController = nil;
	g_currentMission.customTrackSystem 	   = nil;
end;

function GENERAL:mouseEvent(posX, posY, isDown, isUp, button)
end;

function GENERAL:keyEvent(unicode, sym, modifier, isDown)
end;

function GENERAL:update(dt)
	-- This only works for the login in GameExtension GUI
	if GameExtension.HIDDEN_LOGIN_PASSWORD then
		if g_gui.currentGui == nil and g_gui.currentGui == "gameExtensionGUI" then
			if g_gui:getIsDialogVisible("PasswordDialog") then
			-- if g_passwordDialog.isOpen then
				if g_passwordDialog.passwordElement.lastText == nil then
					g_passwordDialog.passwordElement.realText = "";
					g_passwordDialog.passwordElement.lastText = "";
				end;
				
				if g_passwordDialog.passwordElement.text ~= g_passwordDialog.passwordElement.lastText then
					local count 	= g_passwordDialog.passwordElement.text:len();
					local lastCount = g_passwordDialog.passwordElement.lastText:len();
					
					if count < lastCount then
						local toRemove = string.sub(g_passwordDialog.passwordElement.realText, 0, count);
						g_passwordDialog.passwordElement.realText = toRemove;
					else
						local toAdd = string.sub(g_passwordDialog.passwordElement.text, count);
						g_passwordDialog.passwordElement.realText = g_passwordDialog.passwordElement.realText .. toAdd;
					end;
					
					g_passwordDialog.passwordElement.text = "";
					for i = 1, count do 
						g_passwordDialog.passwordElement.text = g_passwordDialog.passwordElement.text .. "*";
					end;
					
					g_passwordDialog.passwordElement.lastText = g_passwordDialog.passwordElement.text;
				end;
			end;
		end;
	end;
end;

function GENERAL:updateTick(dt)
end;

function GENERAL:draw()
end;