-- SCREENSHOT
--
-- @author:    	Xentro (Marcus@Xentro.se)
-- @website:	www.Xentro.se
-- @history:	v1.0 - 2016-11-19 - Initial implementation
-- 

SCREENSHOT = {};

function SCREENSHOT:loadMap()
	-- g_currentMission.drawHudIcon = Utils.overwrittenFunction(g_currentMission.drawHudIcon, SCREENSHOT.drawHudIcon);
	GameExtension.addClassOverride("OVERRIDE_DRAW_HUD_ICON", g_currentMission, "drawHudIcon", SCREENSHOT.drawHudIcon);

	-- Fix your mod dudes
	GameExtension.overrideModClass("FS17_real_clock", "RealClock",      "draw", SCREENSHOT.fixHudMods);	-- Grisu118
	GameExtension.overrideModClass("Inspect17",       "Inspect17",      "draw", SCREENSHOT.fixHudMods);	-- Inspect17
	GameExtension.overrideModClass("MultiOverlayV2",  "MultiOverlayV2", "draw", SCREENSHOT.fixHudMods);	-- HappyLooser
end;

function SCREENSHOT:update(dt)
	if g_currentMission:getIsClient() then
		if self:getIsActiveForInput() then
			if InputBinding.hasEvent(InputBinding.TOGGLE_HIDE_HUD, true) then
				GameExtension.setSetting("SCREENSHOT", "TOGGLE_SCREENSHOT", not GameExtension.getSetting("SCREENSHOT", "TOGGLE_SCREENSHOT"));
			end;
		end;
	end;
end;

function SCREENSHOT:hideHuds(state)
	state = not state;
	
	g_currentMission.showHudEnv = state;
	g_currentMission.showVehicleInfo = state;
	g_currentMission.showVehicleSchema = state;
	g_currentMission.renderTime = state;			-- Marhu's "RealTime" mod use this
	
	g_gameSettings:setValue("showHelpMenu", state);
	
	-- Player module is active
	if GameExtension.getSetting("PLAYER") then
		if not state then
			if GameExtension.getSetting("PLAYER", "CROSSHAIR") then
				GameExtension.setSetting("PLAYER", "CROSSHAIR", state);
				self.crosshairWasActivated = true;
			end;
		else
			if self.crosshairWasActivated ~= nil then
				self.crosshairWasActivated = nil;
				GameExtension.setSetting("PLAYER", "CROSSHAIR", state);
			end;
			
			-- crosshair was hidden before we activated screenshot mode.
		end;
	end;
end;

-- Stop refuel, attach and tip symbol from showing
function SCREENSHOT:drawHudIcon(oldFunc)
	if self.showVehicleInfo then
		oldFunc(self);
	else
		self.activeHudIconName = "";
		self.activeHudIconPriority = 0;
	end;
end;

function SCREENSHOT:fixHudMods(oldFunc)
	if g_currentMission.showHudEnv then
		oldFunc(self);
	end;
end;